<html lang="en">
<head>
<title>Predicates - Enhanced Implementation of Emacs Interpreted Objects</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Enhanced Implementation of Emacs Interpreted Objects">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="prev" href="Writing-Methods.html#Writing-Methods" title="Writing Methods">
<link rel="next" href="Association-Lists.html#Association-Lists" title="Association Lists">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Predicates"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Association-Lists.html#Association-Lists">Association Lists</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Writing-Methods.html#Writing-Methods">Writing Methods</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="index.html#Top">Top</a>
<hr>
</div>

<!-- node-name,  next,  previous,  up -->
<h2 class="chapter">8 Predicates and Utilities</h2>

<p>Now that we know how to create classes, access slots, and define
methods, it might be useful to verify that everything is doing ok.  To
help with this a plethora of predicates have been created.

<div class="defun">
&mdash; Function: <b>class-v</b><var> class<a name="index-class_002dv-27"></a></var><br>
<blockquote><p>Return a vector with all the class's important parts in it.  This vector
is not a copy.  Changing this vector changes the class.  The CLOS method
<code>find-class</code> will have the same effect. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>find-class</b><var> symbol &amp;optional errorp<a name="index-find_002dclass-28"></a></var><br>
<blockquote><p>CLOS function.  In EIEIO it returns the vector definition of the class. 
If there is no class, <code>nil</code> is returned if <var>errorp</var> is
<code>nil</code>. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>class-p</b><var> class<a name="index-class_002dp-29"></a></var><br>
<blockquote><p>Return non-<code>nil</code> if <var>class</var> is a class type. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>object-p</b><var> obj<a name="index-object_002dp-30"></a></var><br>
<blockquote><p>Return non-<code>nil</code> if <var>obj</var> is an object. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>slot-exists-p</b><var> obj-or-class slot<a name="index-slot_002dexists_002dp-31"></a></var><br>
<blockquote><p>Return Non-<code>nil</code> if <var>obj-or-class</var> contains <var>slot</var> in its class. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>slot-boundp</b><var> object slot<a name="index-slot_002dboundp-32"></a></var><br>
<blockquote><p>Non-<code>nil</code> if OBJECT's <var>SLOT</var> is bound. 
Setting a slot's value makes it bound.  Calling <dfn>slot-makeunbound</dfn> will
make a slot unbound. 
<var>OBJECT</var> can be an instance or a class. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>class-name</b><var> class<a name="index-class_002dname-33"></a></var><br>
<blockquote><p>Return a string of the form #&lt;class myclassname&gt; which should look
similar to other lisp objects like buffers and processes.  Printing a
class results only in a symbol. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>class-option</b><var> class option<a name="index-class_002doption-34"></a></var><br>
<blockquote><p>Return the value in <var>CLASS</var> of a given <var>OPTION</var>. 
For example:

     <pre class="example">          (class-option eieio-default-superclass :documentation)
     </pre>
        <p>Will fetch the documentation string for <code>eieio-default-superclass</code>. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>class-constructor</b><var> class<a name="index-class_002dconstructor-35"></a></var><br>
<blockquote><p>Return a symbol used as a constructor for <var>class</var>.  This way you can
make an object of a passed in class without knowing what it is.  This is
not a part of CLOS. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>object-name</b><var> obj<a name="index-object_002dname-36"></a></var><br>
<blockquote><p>Return a string of the form #&lt;object-class myobjname&gt; for <var>obj</var>. 
This should look like lisp symbols from other parts of emacs such as
buffers and processes, and is shorter and cleaner than printing the
object's vector.  It is more useful to use <code>object-print</code> to get
and object's print form, as this allows the object to add extra display
information into the symbol. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>object-class</b><var> obj<a name="index-object_002dclass-37"></a></var><br>
<blockquote><p>Returns the class symbol from <var>obj</var>. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>class-of</b><var> obj<a name="index-class_002dof-38"></a></var><br>
<blockquote><p>CLOS symbol which does the same thing as <code>object-class</code>
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>object-class-fast</b><var> obj<a name="index-object_002dclass_002dfast-39"></a></var><br>
<blockquote><p>Same as <code>object-class</code> except this is a macro, and no
type-checking is performed. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>object-class-name</b><var> obj<a name="index-object_002dclass_002dname-40"></a></var><br>
<blockquote><p>Returns the symbol of <var>obj</var>'s class. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>class-parents</b><var> class<a name="index-class_002dparents-41"></a></var><br>
<blockquote><p>Returns the direct parents class of <var>class</var>.  Returns <code>nil</code> if
it is a superclass. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>class-parents-fast</b><var> class<a name="index-class_002dparents_002dfast-42"></a></var><br>
<blockquote><p>Just like <code>class-parent</code> except it is a macro and no type checking
is performed. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>class-parent</b><var> class<a name="index-class_002dparent-43"></a></var><br>
<blockquote><p>Deprecated function which returns the first parent of <var>class</var>. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>class-children</b><var> class<a name="index-class_002dchildren-44"></a></var><br>
<blockquote><p>Return the list of classes inheriting from <var>class</var>. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>class-children-fast</b><var> class<a name="index-class_002dchildren_002dfast-45"></a></var><br>
<blockquote><p>Just like <code>class-children</code>, but with no checks. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>same-class-p</b><var> obj class<a name="index-same_002dclass_002dp-46"></a></var><br>
<blockquote><p>Returns <code>t</code> if <var>obj</var>'s class is the same as <var>class</var>. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>same-class-fast-p</b><var> obj class<a name="index-same_002dclass_002dfast_002dp-47"></a></var><br>
<blockquote><p>Same as <code>same-class-p</code> except this is a macro and no type checking
is performed. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>object-of-class-p</b><var> obj class<a name="index-object_002dof_002dclass_002dp-48"></a></var><br>
<blockquote><p>Returns <code>t</code> if <var>obj</var> inherits anything from <var>class</var>.  This
is different from <code>same-class-p</code> because it checks for inheritance. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>child-of-class-p</b><var> child class<a name="index-child_002dof_002dclass_002dp-49"></a></var><br>
<blockquote><p>Returns <code>t</code> if <var>child</var> is a subclass of <var>class</var>. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>generic-p</b><var> method-symbol<a name="index-generic_002dp-50"></a></var><br>
<blockquote><p>Returns <code>t</code> if <code>method-symbol</code> is a generic function, as
opposed to a regular emacs list function. 
</p></blockquote></div>

   <p>It is also important to note, that for every created class, a two
predicates are created for it.  Thus in our example, the function
<code>data-object-p</code> is created, and return <code>t</code> if passed an object
of the appropriate type.  Also, the function <code>data-object-child-p</code>
is created which returns <code>t</code> if the object passed to it is of a
type which inherits from <code>data-object</code>.

   </body></html>

